/*
 *      Menu.c
 *
 *      Copyright 2007 Oliver Schwaneberg <oschwa2s@oschwa2s-desktop>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include "Menu.h"


static volatile uint8_t MLOCK = 0;
static uint8_t HH, HL, MH, ML, SH, SL;
static volatile uint8_t menuState = SHOWTIME;

uint8_t getMenuState(void){
	return menuState;
}

void calcMs(void){
	setTimeMs(((uint32_t)getHour()*3600000) + ((uint32_t)getMinute()*60000) + ((uint32_t)getSecond()*1000));
}

void refreshState(void){
	//Gibt es Änderungen?
	switch (getkey())
	{
		case KEY_PLUS : //UP
			switch (menuState)
			{
				case SETTIME_HOUR :
					if(getHour() == 23){
						setHour(0);
					}else{
						setHour(getHour()+1);
					}
					calcMs();
				break;
				case SETTIME_MINUTE :
					if(getMinute() == 59){
						setMinute(0);
					}else{
						setMinute(getMinute()+1);
					}
					calcMs();
				break;
				case SETTIME_SECOND :
					if(getSecond() == 59){
						setSecond(0);
					}else{
						setSecond(getSecond()+1);
					}
					calcMs();
				break;

			}
		break;

		case KEY_MINUS : //DOWN
			switch (menuState)
			{
				case SHOWTIME :
					menuState = SETTIME_HOUR;
					/*cli();
					cbi(TIMSK2, TOIE2);             // disable OCIE2A and TOIE2
					TIMSK0 = (0<<OCIE0A);
					sei();*/
				break;
				case SHOWDATE :
					menuState = SETTIME_HOUR;
					/*cli();
					cbi(TIMSK2, TOIE2);             // disable OCIE2A and TOIE2
					TIMSK0 = (0<<OCIE0A);
					sei();*/
				break;
				case SETTIME_HOUR :
					if(getHour() == 0){
						setHour(23);
					}else{
						setHour(getHour()-1);
					}
					calcMs();
				break;
				case SETTIME_MINUTE :
					if(getMinute() == 0){
						setMinute(59);
					}else{
						setMinute(getMinute()-1);
					}
					calcMs();
				break;
				case SETTIME_SECOND :
					if(getSecond() == 0){
						setSecond(59);
					}else{
						setSecond(getSecond()-1);
					}
					calcMs();
				break;

			}
		break;

		case KEY_NEXT :
			switch (menuState)
			{
				case SETTIME_HOUR :
					menuState = SETTIME_MINUTE;
				break;
				case SETTIME_MINUTE :
					menuState = SETTIME_SECOND;
				break;
				case SETTIME_SECOND :
					menuState = SHOWTIME;
					/*cli();
					TIFR2 = 0xFF;           // clear interrupt-flags
					sbi(TIMSK2, TOIE2);     // enable Timer2 overflow interrupt
					TIMSK0 = (1<<OCIE0A);
					sei();*/
				break;

			}
		break;

		case KEY_PREV :
			switch (menuState)
			{
				case SETTIME_HOUR :
					menuState = SHOWTIME;
					/*cli();
					TIFR2 = 0xFF;           // clear interrupt-flags
					sbi(TIMSK2, TOIE2);     // enable Timer2 overflow interrupt
					TIMSK0 = (1<<OCIE0A);
					sei();*/
				break;
				case SETTIME_MINUTE :
					menuState = SETTIME_HOUR;
				break;
				case SETTIME_SECOND :
					menuState = SETTIME_MINUTE;
				break;

			}
		break;
	}
}

void refreshMenu(){
/*	if(!MLOCK)
		MLOCK = 1;
	else
		return;*/

	switch (menuState)
	{
		case SHOWTIME :

			/*if (clockformat == CLOCK_12)    // if 12H clock
				HH = CHAR2BCD2(TBL_CLOCK_12[gHOUR]);
			else*/
			/*HH = CHAR2BCD2(getHour());

			HL = (HH & 0x0F) + '0';
			HH = (HH >> 4) + '0';

			MH = CHAR2BCD2(getMinute());
			ML = (MH & 0x0F) + '0';
			MH = (MH >> 4) + '0';

			SH = CHAR2BCD2(getSecond());
			SL = (SH & 0x0F) + '0';
			SH = (SH >> 4) + '0';

			LCD_putc(0, HH);
			LCD_putc(1, HL);
			LCD_putc(2, MH);
			LCD_putc(3, ML);
			LCD_putc(4, SH);
			LCD_putc(5, SL);
			LCD_putc(6, '\0');

			LCD_Colon(1);

			LCD_UpdateRequired(TRUE, 0);*/


		break;
		case SETTIME_HOUR :
			/*HH = CHAR2BCD2(getHour());
			HL = (HH & 0x0F) + '0';
			HH = (HH >> 4) + '0';

			LCD_putc(0, HH);
			LCD_putc(1, HL);
			LCD_putc(2, '\0');

			LCD_Colon(1);

			LCD_UpdateRequired(TRUE, 0);*/
		break;
		case SETTIME_MINUTE :
			/*MH = CHAR2BCD2(getMinute());
			ML = (MH & 0x0F) + '0';
			MH = (MH >> 4) + '0';
			LCD_putc(0, ' ');
			LCD_putc(1, ' ');
			LCD_putc(2, MH);
			LCD_putc(3, ML);
			LCD_putc(4, '\0');

			LCD_Colon(1);

			LCD_UpdateRequired(TRUE, 0);*/
		break;
		case SETTIME_SECOND :
			/*SH = CHAR2BCD2(getSecond());
			SL = (SH & 0x0F) + '0';
			SH = (SH >> 4) + '0';
			LCD_putc(0, ' ');
			LCD_putc(1, ' ');
			LCD_putc(2, ' ');
			LCD_putc(3, ' ');
			LCD_putc(4, SH);
			LCD_putc(5, SL);
			LCD_putc(6, '\0');

			LCD_Colon(1);

			LCD_UpdateRequired(TRUE, 0);*/
		break;
		default:
		//LCD_puts("ERROR\0", 0);
		/*LCD_putc(0, 'E');
		LCD_putc(1, '\0');
		LCD_Colon(1);
		LCD_UpdateRequired(TRUE, 0);*/
	}

	//MLOCK = 0;
}
