//*****************************************************************************
//
//  File........: RTC.h
//
//  Author(s)...: ATMEL Norway
//
//  Target(s)...: ATmega169
//
//  Description.: Functions for RTC.c
//
//  Revisions...: 1.0
//
//  YYYYMMDD - VER. - COMMENT                                       - SIGN.
//
//  20021015 - 1.0  - File created                                  - LHM
//  20031009          port to avr-gcc/avr-libc                      - M.Thomas
//  20060602		  Stripped down									- O.Schwaneberg
//
//*****************************************************************************
#ifndef RTC
#define RTC

#include "ADC.h"
#include "Comm.h"
#include "Prometheus.h"
#include "database.h"
#include "Menu.h"
#include "drivers/lcd.h"

int8_t countdown, countdown2, Wcountdown;

//  Function declarations
void RTC_init(void);            //initialize the Timer Counter 2 in asynchron operation
//void sendTime(void);
uint8_t getSecond(void);
uint8_t getMinute(void);
uint8_t getHour(void);
//uint16_t getDay(void);

void setMinute(uint8_t);
void setHour(uint8_t);
void setSecond(uint8_t);

void setBacklightAutoOff(uint16_t seconds);

void calcMs(void);

#endif
