#ifndef BUTTON_H_
#define BUTTON_H_

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <inttypes.h>
#include <util/delay.h>

#include "RTC.h"
#include "Menu.h"

#define TRUE 1
#define FALSE 0
#define NULL 0

#define PINA_MASK ((1<<PINA3)|(1<<PINA4)|(1<<PINA5)|(1<<PINA6)|(1<<PINA7))

#define BUTTON_A    3   // UP
#define BUTTON_B    5   // DOWN
#define BUTTON_C    4   // LEFT
#define BUTTON_D    6   // RIGHT
#define BUTTON_O    7   // PUSH

//Button definitions

#define KEY_NULL    0
#define KEY_ENTER   BUTTON_O //PUSH/CENTER
#define KEY_NEXT    BUTTON_D //RIGHT
#define KEY_PREV    BUTTON_C //LEFT
#define KEY_PLUS    BUTTON_A //UP
#define KEY_MINUS   BUTTON_B //DOWN


void keyHandler(void);
char getkey(void);

#endif
