/*Created by O.Schwaneberg in 2008

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
        MA 02110-1301, USA.*/

#include "drivers/powerControl.h"

/*
 * Methoden zum Ein- und Ausschalten des ATX-Netzteils
 */
void switchOnATX(void){
	PORTD &= ~(1<<PD2);
}
void switchOffATX(void){
	PORTD |= (1<<PD2);
}

/*
 * Übergibt den Status des ATX-Netzteils
 */
char isOnATX(void){
	return !(PORTD & (1<<PD2));
}

/*
 * Diese Methode gibt den Wert von ATX PWR-OK wieder
 */
char isPowerOk(void){
	return (PIND & (1<<PIND3));
}

/* Aktiviert die Versorgung der 3,3V RGB-LEDs über den Spannungsregler
 * Somit ist die Versorgung im ATX-Standbye-Modus möglich
 */
void switchToVoltageRegulator(void){
	PORTD &= ~(1<<PD6);
}
/*
 * Aktiviert die Versorgung der 3,3V RGB-LEDs direkt über das Netzteil
 * Dies ist NICHT im ATX-Standbye-Modus möglich!
 */
void switchToVoltageSupply(void){
	PORTD |= (1<<PD6);
}

/*
 * Werden die 3,3V LED-Spannung durch den Spannungsregler erzeugt?
 */
char isOnVoltageRegulator(void){
	return !(PORTD & (1<<PD6));
}
