/*Created by O.Schwaneberg in 2008

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
        MA 02110-1301, USA.*/
        
#ifndef _POWERCONTROL_
#define _POWERCONTROL_

#include <avr/io.h>

/*
 * Methoden zum Ein- und Ausschalten des ATX-Netzteils
 */
void switchOnATX(void);
void switchOffATX(void);

/*
 * Übergibt den Status des ATX-Netzteils
 */
char isOnATX(void);

/*
 * Diese Methode gibt den Wert von ATX PWR-OK wieder
 */
char isPowerOk(void);

/* Aktiviert die Versorgung der 3,3V RGB-LEDs über den Spannungsregler
 * Somit ist die Versorgung im ATX-Standbye-Modus möglich
 */
void switchToVoltageRegulator(void);
/*
 * Aktiviert die Versorgung der 3,3V RGB-LEDs direkt über das Netzteil
 * Dies ist NICHT im ATX-Standbye-Modus möglich!
 */
void switchToVoltageSupply(void);

/*
 * Werden die 3,3V LED-Spannung durch den Spannungsregler erzeugt?
 */
char isOnVoltageRegulator(void);

#endif
